/* memcopy.h -- definitions for memory copy functions.  Haquered-up Alpha
   version.
   Copyright (C) 1991 Free Software Foundation, Inc.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

#include "../generic/memcopy.h"
#include <sys/types.h>

#undef	OP_T_THRES
#define	OP_T_THRES	32

/*
 * We weenoid out and use byte ops for now, 'cause they actually work
 * instead of segfaulting. If someone wants to figure out what they
 * should be, by all means...
 */

#ifndef PTR
#define PTR char *
#endif

static inline void WORD_COPY_FWD2(PTR *dst_bps,PTR *src_bps,size_t *nbytes_left,size_t nbytes) {
   if(((long)(*src_bps))&7) {
      char *dst_bp=(*dst_bps);
      char *src_bp=(*src_bps);
      while(nbytes-->0) {
	 *(dst_bp++)=(*(src_bp++));
      }
      (*dst_bps)=dst_bp;
      (*src_bps)=src_bp;
      (*nbytes_left)=0;
   }
   else {
      int nwords=nbytes/8;
      long *dst_bp=(*dst_bps);
      long *src_bp=(*src_bps);
      (*nbytes_left)=nbytes-nwords*8;
      while(nwords--) {
	 (*(dst_bp++))=(*(src_bp++));
      }
      (*dst_bps)=dst_bp;
      (*src_bps)=src_bp;
   }
}

#undef WORD_COPY_FWD
#define WORD_COPY_FWD(dst_bp,src_bp,nbytes_left,nbytes) WORD_COPY_FWD2(&(dst_bp),&(src_bp),&(nbytes_left),nbytes)

static inline void WORD_COPY_BWD2(PTR *dst_eps,PTR *src_eps,size_t *nbytes_left,size_t nbytes) {
  char *dst_ep=(*dst_eps);
  char *src_ep=(*src_eps);
  while(nbytes-->0) {
    *(--dst_ep)=(*(--src_ep));
  }
  (*src_eps)=src_ep;
  (*dst_eps)=dst_ep;
  (*nbytes_left)=0;
}

#undef	WORD_COPY_BWD
#define WORD_COPY_BWD(dst_ep, src_ep, nbytes_left, nbytes) WORD_COPY_BWD2(&(dst_ep),&(src_ep),&(nbytes_left),nbytes)
