#include <syscall.h>
#include <signal.h>
#include <unistd.h>

int
__sigprocmask(int how, const sigset_t *set, sigset_t *oldset)
{
	long toset, result;
	extern long __osf_sigprocmask (int how, long toset);

	if (set) {
		toset = *set;
	} else {
		toset = 0;
		how = SIG_BLOCK;
	}
	result = __osf_sigprocmask(how, toset);
	if (result == -1) {
		return result;
	}
	if (oldset) {
		*oldset = result;
	}
	return 0;
}
