#include <sys/times.h>
#include <sys/resource.h>
#include <errno.h>

#define totime(x) ((x).tv_sec*100+(x).tv_usec/10000)

clock_t
__times(struct tms *tp)
{
	struct rusage r;

	if (tp == NULL) {
		errno = EINVAL;
		return -1;
	}

	if (getrusage(RUSAGE_SELF,&r) < 0) {
		return -1;
	}
	tp->tms_utime = totime(r.ru_utime);
	tp->tms_stime = totime(r.ru_stime);
   
	if (getrusage(RUSAGE_CHILDREN, &r) < 0) {
		return -1;
	}
	tp->tms_cutime=totime(r.ru_utime);
	tp->tms_cstime=totime(r.ru_stime);

	return time(0);
}
