/* This is a butchered version of the gcrt0.S that appeared in the
 * Linux/Alpha 1.0 distribution.
 */

/*
 * Copyright (c) 1993 Eric Youngdale, Peter MacDonald, David Engel
 * and Hongjiu Lu.
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by Eric Youngdale,
 *      Peter MacDonald, David Engel and Hongjiu Lu.
 * 3. The name of the above contributors may not be
 *    used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/* Notice of general intent:
 *
 * The linux operating system generally contains large amounts of code
 * that fall under the GNU General Public License, or GPL for short.
 * This file contains source code that by it's very nature would always
 * be linked with an application program, and because of this a GPL type
 * of copyright on this file would place restrictions upon the
 * distribution of binary-only commercial software.  Since the goal of the
 * Linux project as a whole is not to discourage the development and
 * distribution of commercial software for Linux, this file has been placed
 * under a more relaxed BSD-style of copyright.
 *
 * It is the general understanding of the above contributors that a
 * program executable linked to a library containing code that falls
 * under the GPL or GLPL style of license is not subject to the terms of
 * the GPL or GLPL license if the program executable(s) that are supplied
 * are linked to a shared library form of the GPL or GLPL library, and as long
 * as the form of the shared library is such that it is possible for
 * the end user to modify and rebuild the library and use it in
 * conjunction with the program executable.
 */

#include <alpha/regdef.h>
#include <asm/pal.h>

	.text
	.globl	__start
	.ent	__start
__start:
/*
 * The first thing we do is try to load the shared library. If that
 * fails, it won't return.
 */
	/* JRP STUB - Don't do this for now... */
	/* jsr	ra,___load_shared_libraries */
/*
 *	Establish current brk.
 *	This is important, and was missing from the new version...
 */
	br	pv,1f
1:	ldgp	gp,0(pv)
	lda	sp,-16(sp)
	lda	v0,17(zero)
	xor	a0,a0,a0
	call_pal	PAL_callsys
	stq	v0,___brk_addr

	/* Make sure the stack is quadword-aligned! */
	bic	sp,7,sp

	/* Save the GP on the stack... */
	stq	gp,0(sp)
/*
 *	Setup profiling
 */

	lda	a0,_mcleanup
 	jsr	ra,atexit
	ldq	gp,0(sp)

	lda	a0,__start
	lda	a1,_etext
	jsr	ra,monstartup
	ldq	gp,0(sp)

/*
 *	ok, set up the environ and call main
 */

	/* JRP - Intel sets up fpcr here... what do we do? */
	jsr	ra,__libc_init
	ldq	gp,0(sp)

	/* 
	 * Make sure environ is set up *before* we call the
	 * constructor/destructor list
	 */
	ldl	a0,16(sp)		/* argc */
	lda	a1,24(sp)		/* argv */
	s8addq	a0,a1,a2
	addq	a2,0x8,a2
	stq	a2,environ

	/* Call the constructor/destructor list */
	jsr	ra,__main
	ldq	gp,0(sp)

	ldl	a0,16(sp)		/* argc */
	lda	a1,24(sp)		/* argv */
	ldq	a2,environ

	jsr	ra,main
	ldq	gp,0(sp)
	bis	v0,v0,a0
	jsr	ra,exit
/*
 *	Just in case _exit fails... We use trap #0 for __exit().
 */
done:
	lda	v0,1(zero)
	call_pal	PAL_callsys
	br	zero,done

	.end	__start
